EGL_Stat = {
	 [0] = _G["ALL"],
	 [1] = _G["ITEM_MOD_STAMINA_SHORT"],
	 [2] = _G["ITEM_MOD_INTELLECT_SHORT"],
	 [3] = _G["ITEM_MOD_SPIRIT_SHORT"],
	 [4] = _G["ITEM_MOD_STRENGTH_SHORT"],
	 [5] = _G["ITEM_MOD_HASTE_RATING_SHORT"],
	 [6] = _G["ITEM_MOD_AGILITY_SHORT"],
	 [7] = _G["ITEM_MOD_HIT_RATING_SHORT"],
	 [8] = _G["ITEM_MOD_CRIT_RATING_SHORT"],
	 [9] = _G["ITEM_MOD_MASTERY_RATING_SHORT"],
	[10] = _G["ITEM_MOD_DODGE_RATING_SHORT"],
	[11] = _G["ITEM_MOD_PARRY_RATING_SHORT"],
	[12] = _G["ITEM_MOD_EXPERTISE_RATING_SHORT"],
	[13] = _G["ITEM_MOD_BLOCK_RATING_SHORT"],
	[14] = _G["ITEM_MOD_RESILIENCE_RATING_SHORT"],
	[15] = _G["ITEM_MOD_SPELL_POWER_SHORT"],
	[16] = _G["ITEM_MOD_SPELL_PENETRATION_SHORT"]
}

EGL_Slot = {
	[0] = _G["ALL"],
    [1] = _G["RED_GEM"],
    [2] = _G["BLUE_GEM"],
    [3] = _G["YELLOW_GEM"],
    [4] = _G["META_GEM"]
}

EGL_Quali = {
	[0] = _G["ALL"],
	[1] = _G["ITEM_QUALITY_COLORS"][2].hex.._G["ITEM_QUALITY2_DESC"],  -- "Selten";
	[2] = _G["ITEM_QUALITY_COLORS"][3].hex.._G["ITEM_QUALITY3_DESC"], -- "Rar";
	[3] = _G["ITEM_QUALITY_COLORS"][4].hex.._G["ITEM_QUALITY4_DESC"] -- "Episch";
}

EGL_Level = {
	[0] = _G["ALL"],
	[1] = "BC",
	[2] = "WotLK",
	[3] = "Cataclysm"
}

EGL_Op = {
	[0] = "=",
	[1] = ">=",
	[2] = "<="
}


-- JC CHECKBUTTON ------------------------------------------------

function EGL_CheckButton_OnClick(this)
	if CheckButtonJC:GetChecked() then
		EGL_Options["jc"] = true;
		if (EGL_Options["cataclysm"]) then
			EGL_Options["jc_cata"] = true;
		end
	else 
		EGL_Options["jc"] = false;
		EGL_Options["jc_cata"] = false;
	end
	EGL_ScrollBar_Update();
end

-- DETAILS CHECKBUTTON ------------------------------------------------

function EGL_CheckButtonDetails_OnClick(this)
	local i;
	if CheckButtonDetails:GetChecked() then
		EGL_Options["details"] = true;
	else 
		EGL_Options["details"] = false;
	end
	for i = 1, 15 do
		item = _G["EGLItem_"..i];
		item:Hide();
	end
	EGL_ScrollBar_Update();
end

-- SLOT DROPDOWN ------------------------------------------------

function EGL_SlotDropDown_Init()
	local entries = table.getn(EGL_Slot);
	for i=0,entries do
		info = {};
		value = i;
		text = EGL_Slot[i];
		info.value = value;
		info.text = text;
		info.func = EGL_SlotDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_SlotDropDown_OnShow()
    UIDropDownMenu_Initialize(EGL_SlotDropDown, EGL_SlotDropDown_Init);
    UIDropDownMenu_SetSelectedID(EGL_SlotDropDown, EGL_Options["SelectedSlot"]+1);
    UIDropDownMenu_SetWidth(EGL_SlotDropDown, 70);
    EGL_ScrollBar_Update();
end

function EGL_SlotDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_SlotDropDown, i);
    EGL_Options["SelectedSlot"] = i-1;
    EGL_ScrollBar_Update();
end

-- STAT DROPDOWN ------------------------------------------------

function EGL_StatDropDown_Init()
	local entries = table.getn(EGL_Stat);
	for i=0,entries do
		info = {};
		info = UIDropDownMenu_CreateInfo();
		value = i;
		text = EGL_Stat[i];
		info.text = text;
		info.value = value;
		info.func = EGL_StatDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_StatDropDown_OnShow()
    UIDropDownMenu_Initialize(EGL_StatDropDown, EGL_StatDropDown_Init);
    UIDropDownMenu_SetSelectedID(EGL_StatDropDown, EGL_Options["SelectedStat"]+1);
    UIDropDownMenu_SetWidth(EGL_StatDropDown, 150);
    EGL_ScrollBar_Update();
end

function EGL_StatDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_StatDropDown, i);
    EGL_Options["SelectedStat"] = i-1;
    EGL_ScrollBar_Update();
end

-- QUALI OP ------------------------------------------------

function EGL_QualiOp_Init()
	local entries = table.getn(EGL_Op);
	for i=0,entries do
		info = {};
		value = i;
		text = EGL_Op[i];
		info.value = value;
		info.text = text;
		info.func = EGL_QualiOp_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_QualiOp_OnShow()
    UIDropDownMenu_Initialize(EGL_QualiOp, EGL_QualiOp_Init);
    UIDropDownMenu_SetSelectedID(EGL_QualiOp, EGL_Options["SelectedQualiOp"]+1);
    UIDropDownMenu_SetWidth(EGL_QualiOp, 40);
    EGL_ScrollBar_Update();
end

function EGL_QualiOp_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_QualiOp, i);
    EGL_Options["SelectedQualiOp"] = i-1;
    EGL_ScrollBar_Update();
end

-- QUALITY DROPDOWN ------------------------------------------------

function EGL_QualiDropDown_Init()
	local entries = table.getn(EGL_Quali);
	for i=0,entries do
		info = {};
		value = i;
		text = EGL_Quali[i];
		info.text = text;
		info.value = value;
		info.func = EGL_QualiDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_QualiDropDown_OnShow()
    UIDropDownMenu_Initialize(EGL_QualiDropDown, EGL_QualiDropDown_Init);
    UIDropDownMenu_SetSelectedID(EGL_QualiDropDown, EGL_Options["SelectedQuali"]+1);
    UIDropDownMenu_SetWidth(EGL_QualiDropDown, 80);
    EGL_ScrollBar_Update();
end

function EGL_QualiDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_QualiDropDown, i);
    EGL_Options["SelectedQuali"] = i-1;
    EGL_ScrollBar_Update();
end

-- LEVEL OP ------------------------------------------------

function EGL_LevelOp_Init()
	local entries = table.getn(EGL_Op);
	for i=0,entries do
		info = {};
		value = i;
		text = EGL_Op[i];
		info.value = value;
		info.text = text;
		info.func = EGL_LevelOp_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_LevelOp_OnShow()
    UIDropDownMenu_Initialize(EGL_LevelOp, EGL_LevelOp_Init);
    UIDropDownMenu_SetSelectedID(EGL_LevelOp, EGL_Options["SelectedLevelOp"]+1);
    UIDropDownMenu_SetWidth(EGL_LevelOp, 40);
    EGL_ScrollBar_Update();
end

function EGL_LevelOp_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_LevelOp, i);
    EGL_Options["SelectedLevelOp"] = i-1;
    EGL_ScrollBar_Update();
end

-- ITEMLEVEL DROPDOWN ------------------------------------------------

function EGL_LevelDropDown_Init()
	local entries = table.getn(EGL_Level);
	if (EGL_Options["cataclysm"] == false) then
		entries = entries - 1;
	end
	for i=0,entries do
		info = {};
		value = i;
		text = EGL_Level[i];
		info.text = text;
		info.value = value;
		info.func = EGL_LevelDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_LevelDropDown_OnShow()
    UIDropDownMenu_Initialize(EGL_LevelDropDown, EGL_LevelDropDown_Init);
    UIDropDownMenu_SetSelectedID(EGL_LevelDropDown, EGL_Options["SelectedLevel"]+1);
    UIDropDownMenu_SetWidth(EGL_LevelDropDown, 80);
    EGL_ScrollBar_Update();
end

function EGL_LevelDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_LevelDropDown, i);
    EGL_Options["SelectedLevel"] = i-1;
    EGL_ScrollBar_Update();
end

-- CLASS & SPEC DROPDOWN ------------------------------------------------

function EGL_SepcSort(a,b)
	local _, class = UnitClass("player");
	local ssl = EGL_SSL;
	-- put ALL on top
	if (ssl[a]["classid"] == -1) then
		return true;
	end
	if (ssl[b]["classid"] == -1) then
		return false;
	end
	-- sort Class and Spec by localized names and put own class on top
	if (ssl[a]["classname"] == class) and (ssl[b]["classname"] == class) then
		if ssl[a]["localname"] > ssl[b]["localname"] then
			return true;
		else
			return false;
		end
	elseif ssl[a]["classname"] == class then
		return true;
	elseif ssl[b]["classname"] == class then
		return false;
	elseif ssl[a]["localname"] > ssl[b]["localname"] then
		return true;
	else
		return false;
	end
end


function EGL_SpecDropDown_Init()
	local entries = table.getn(EGL_CR);
	local _, class = UnitClass("player");
	cid = 1;
	EGL_SSL = {};
	EGL_SSL[0] = {};
	EGL_SSL[0]["classid"] = -1;
	EGL_SSL[0]["classname"] = "AAA";
	EGL_SSL[0]["localname"] = _G["ALL"];
	for i=0,entries do
		local specentries = table.getn(EGL_CR[i]);
		if specentries > 0 then
			for j=1,specentries do
				local temp = {};
				temp["classid"] = i;
				temp["classname"] = EGL_CR[i][0];
				temp["specid"] = j;
				temp["hint"] = EGL_CR[i][j][3];
				if specentries > 1 then
					-- Class and Spec
					temp["localname"] = EGL_ClassNames[i].." ("..EGL_SpecNames[EGL_CR[i][j][0]]..")";
				else
					-- Only Class (just one spec)
					temp["localname"] = EGL_ClassNames[i];
				end
				table.insert(EGL_SSL,cid,temp);
				cid = cid + 1;
			end
		end
	end
	-- Sort Spec List
	-- table.sort(EGL_SSL, EGL_SpecSort);
	local entries = table.getn(EGL_SSL);
	for i=0,entries do
		info = {};
		value = {};
		if EGL_SSL[i]["classname"] == class then
			text = _G["ITEM_QUALITY_COLORS"][2].hex..EGL_SSL[i]["localname"];
		else
			text = EGL_SSL[i]["localname"];
		end
		info.text = text;
		info.value = value;
		info.func = EGL_SpecDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_SpecDropDown_OnShow()
    UIDropDownMenu_Initialize(EGL_SpecDropDown, EGL_SpecDropDown_Init);
    UIDropDownMenu_SetSelectedID(EGL_SpecDropDown, EGL_Options["SelectedSpec"]+1);
    UIDropDownMenu_SetWidth(EGL_SpecDropDown, 150);
	if EGL_Options["SelectedSpec"] > 0 then
		egl_hint = _G["EGL_HINT"];
		if EGL_SSL[EGL_Options["SelectedSpec"]]["hint"] ~= nil then
			egl_hint:SetText(EGL_SSL[EGL_Options["SelectedSpec"]]["hint"]);
		else
			egl_hint:SetText("");
		end
	end
    EGL_ScrollBar_Update();
end

function EGL_SpecDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_SpecDropDown, i);
    EGL_Options["SelectedSpec"] = i-1;
	if EGL_Options["SelectedSpec"] > 0 then
		egl_hint = _G["EGL_HINT"];
		if EGL_SSL[EGL_Options["SelectedSpec"]]["hint"] ~= nil then
			egl_hint:SetText(EGL_SSL[EGL_Options["SelectedSpec"]]["hint"]);
		else
			egl_hint:SetText("");
		end
	else
		egl_hint:SetText("");
	end
    EGL_ScrollBar_Update();
end
